#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <assert.h>

#define IDEA_KEY_NELEMS 8 /*number of 16-bit keyword (8*16 = 128). IDEA use 128 bit key*/
#define IDEA_ROUND_KEY_NELEMS 52 /*number of round key*/ 

#define CRLF "\r\n"
#define return_if_fail(expr) \
do { \
        if (!(expr)) { \
                fprintf(stderr, "file %s line %d %s(): expression `%s' failed" CRLF, \
                        __FILE__, \
                        __LINE__, \
                        __FUNCTION__, \
#expr); \
                return; \
} \
} while (0)

static inline u_int16_t mul(u_int16_t a, u_int16_t b);
static inline u_int16_t sum(u_int16_t a, u_int16_t b);

struct idea_context *set_new_context();
void idea_context_free(struct idea_context **ctx);
void get_key(u_int16_t *key, struct idea_context *ctx);
void sckrambling(struct idea_context *ctx);
void invertkey(struct idea_context  *ctx);

u_int16_t mulinv(u_int16_t x);
u_int16_t addinv(u_int16_t x);